schema = {
    "$schema": "https://json-schema.org/draft/2020-12/schema",
    "title": "_PangraphSchemaRoot",
    "description": "AUTOGENERATED! This JSON schema file is generated automatically from Rust types.\n The root object definition is a dummy container for the types being exposed. Disregard\n it. Instead, see the actual types in the `definitions` property of that container.",
    "type": "object",
    "properties": {"pangraph": {"$ref": "#/$defs/Pangraph"}},
    "required": ["pangraph"],
    "$defs": {
        "Pangraph": {
            "type": "object",
            "properties": {
                "paths": {
                    "type": "object",
                    "additionalProperties": {"$ref": "#/$defs/PangraphPath"},
                },
                "blocks": {
                    "type": "object",
                    "additionalProperties": {"$ref": "#/$defs/PangraphBlock"},
                },
                "nodes": {
                    "type": "object",
                    "additionalProperties": {"$ref": "#/$defs/PangraphNode"},
                },
            },
            "required": ["paths", "blocks", "nodes"],
        },
        "PangraphPath": {
            "type": "object",
            "properties": {
                "id": {"$ref": "#/$defs/PathId"},
                "nodes": {"type": "array", "items": {"$ref": "#/$defs/NodeId"}},
                "tot_len": {"type": "integer", "format": "uint", "minimum": 0},
                "circular": {"type": "boolean"},
                "name": {"type": ["string", "null"]},
                "desc": {"type": ["string", "null"]},
            },
            "required": ["id", "nodes", "tot_len", "circular"],
        },
        "PathId": {"type": "integer", "format": "uint", "minimum": 0},
        "NodeId": {"type": "integer", "format": "uint", "minimum": 0},
        "PangraphBlock": {
            "type": "object",
            "properties": {
                "id": {"$ref": "#/$defs/BlockId"},
                "consensus": {"type": "string"},
                "alignments": {
                    "type": "object",
                    "additionalProperties": {"$ref": "#/$defs/Edit"},
                },
            },
            "required": ["id", "consensus", "alignments"],
        },
        "BlockId": {"type": "integer", "format": "uint", "minimum": 0},
        "Edit": {
            "type": "object",
            "properties": {
                "subs": {"type": "array", "items": {"$ref": "#/$defs/Sub"}},
                "dels": {"type": "array", "items": {"$ref": "#/$defs/Del"}},
                "inss": {"type": "array", "items": {"$ref": "#/$defs/Ins"}},
            },
            "required": ["subs", "dels", "inss"],
        },
        "Sub": {
            "type": "object",
            "properties": {
                "pos": {"type": "integer", "format": "uint", "minimum": 0},
                "alt": {"type": "string", "minLength": 1, "maxLength": 1},
            },
            "required": ["pos", "alt"],
        },
        "Del": {
            "type": "object",
            "properties": {
                "pos": {"type": "integer", "format": "uint", "minimum": 0},
                "len": {"type": "integer", "format": "uint", "minimum": 0},
            },
            "required": ["pos", "len"],
        },
        "Ins": {
            "type": "object",
            "properties": {
                "pos": {"type": "integer", "format": "uint", "minimum": 0},
                "seq": {"type": "string"},
            },
            "required": ["pos", "seq"],
        },
        "PangraphNode": {
            "type": "object",
            "properties": {
                "id": {"$ref": "#/$defs/NodeId"},
                "block_id": {"$ref": "#/$defs/BlockId"},
                "path_id": {"$ref": "#/$defs/PathId"},
                "strand": {"$ref": "#/$defs/Strand"},
                "position": {
                    "type": "array",
                    "prefixItems": [
                        {"type": "integer", "format": "uint", "minimum": 0},
                        {"type": "integer", "format": "uint", "minimum": 0},
                    ],
                    "minItems": 2,
                    "maxItems": 2,
                },
            },
            "required": ["id", "block_id", "path_id", "strand", "position"],
        },
        "Strand": {"type": "string", "enum": ["+", "-"]},
    },
}
